SystemOrganization addCategory: #MorphoPhysics!

PolygonMorph subclass: #ForceMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics'!

!ForceMorph methodsFor: 'initialization' stamp: 'hjo 3/6/2009 16:44'!
initialize

	super initialize.
	self makeOpen.
	self setVertices: (Array with: 0@0 with: 100@80).
	self borderColor:  (Color r: 0.847 g: 0.219 b: 0.976).
	self borderWidth: 6.
	self makeForwardArrow! !

PolygonMorph subclass: #SpringMorph
	instanceVariableNames: 'stableLength attachedBodyMorph1 attachedBodyMorph2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics'!

!SpringMorph methodsFor: 'accessing' stamp: 'hjo 3/7/2009 12:41'!
attachedBodyMorph1

	attachedBodyMorph1 setDefault: #defaultAttachedBodyMorph1 for: self withSetter: #attachedBodyMorph1: .
	^attachedBodyMorph1! !

!SpringMorph methodsFor: 'accessing' stamp: 'hjo 3/7/2009 12:41'!
attachedBodyMorph1: anObject
		
	attachedBodyMorph1 := anObject! !

!SpringMorph methodsFor: 'accessing' stamp: 'hjo 3/7/2009 12:41'!
attachedBodyMorph2

	attachedBodyMorph2 setDefault: #defaultAttachedBodyMorph2 for: self withSetter: #attachedBodyMorph2: .
	^attachedBodyMorph2! !

!SpringMorph methodsFor: 'accessing' stamp: 'hjo 3/7/2009 12:41'!
attachedBodyMorph2: anObject
		
	attachedBodyMorph2 := anObject! !

!SpringMorph methodsFor: 'testing' stamp: 'hjo 3/7/2009 12:44'!
bothEndsAttached

	^self attachedBodyMorph1 notNil and: [self attachedBodyMorph2 notNil]! !

!SpringMorph methodsFor: 'defaults' stamp: 'hjo 3/7/2009 15:14'!
defaultAttachedBodyMorph1

	^UnmovableBodyMorph new openInWorld
		center: self vertices first! !

!SpringMorph methodsFor: 'defaults' stamp: 'hjo 3/7/2009 15:14'!
defaultAttachedBodyMorph2

	^UnmovableBodyMorph new openInWorld
		center: self vertices second! !

!SpringMorph methodsFor: 'defaults' stamp: 'hjo 3/6/2009 16:49'!
defaultStableLength

	"Return a default object for instance variable stableLength."
	^100! !

!SpringMorph methodsFor: 'initialization' stamp: 'hjo 3/7/2009 15:39'!
initialize

	super initialize.
	self makeOpen.
	self beSticky.
	self setVertices: (Array with: 0@0 with: 100@80).
	self borderColor:  Color black.
	self borderWidth: 6.! !

!SpringMorph methodsFor: 'accessing' stamp: 'hjo 3/6/2009 16:49'!
stableLength

	stableLength setDefault: #defaultStableLength for: self withSetter: #stableLength: .
	^stableLength! !

!SpringMorph methodsFor: 'accessing' stamp: 'hjo 3/6/2009 16:49'!
stableLength: anObject
		
	stableLength := anObject! !

!SpringMorph methodsFor: 'stepping and presenter' stamp: 'hjo 3/7/2009 15:10'!
step

	| currentLength k x f vector newVertices |
	super step.

	newVertices := Array with: self attachedBodyMorph1 center with: self attachedBodyMorph2 center.
	
	self setVertices: newVertices.
	vector := newVertices first - newVertices second. "tracting direction"
	currentLength := vector r.
	self borderWidth: (self stableLength / currentLength) sqrt * 5.
	k := 3.
	x := currentLength - self stableLength.
	f := k * x * vector normalized.
	self attachedBodyMorph1 forcedBy: f negated.
	self attachedBodyMorph2 forcedBy: f.! !

!SpringMorph methodsFor: 'testing' stamp: 'hjo 3/6/2009 16:56'!
stepTime

	^50! !

!Player methodsFor: '*MorphoPhysics' stamp: 'hjo 3/12/2009 17:14'!
getMass

	^costume mass! !

!Player methodsFor: '*MorphoPhysics' stamp: 'hjo 3/12/2009 17:14'!
setMass: aNumber

	costume mass: aNumber! !

EllipseMorph subclass: #RigidBodyMorph
	instanceVariableNames: 'mass velocity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics'!

!RigidBodyMorph methodsFor: 'physics' stamp: 'hjo 3/6/2009 17:19'!
acceleratedBy: aPoint 

	self velocity: self velocity + aPoint! !

!RigidBodyMorph methodsFor: 'defaults' stamp: 'hjo 3/7/2009 15:29'!
defaultMass

	"Return a default object for instance variable mass."
	^500! !

!RigidBodyMorph methodsFor: 'defaults' stamp: 'hjo 3/6/2009 16:58'!
defaultVelocity

	"Return a default object for instance variable velocity."
	^0@0! !

!RigidBodyMorph methodsFor: 'physics' stamp: 'hjo 3/7/2009 15:12'!
forcedBy: aPoint 

	self acceleratedBy: aPoint / self mass! !

!RigidBodyMorph methodsFor: 'initialization' stamp: 'hjo 3/6/2009 16:48'!
initialize

	super initialize.
	self color: Color brown.
	self ballStyle! !

!RigidBodyMorph methodsFor: 'accessing' stamp: 'hjo 3/6/2009 16:58'!
mass

	mass setDefault: #defaultMass for: self withSetter: #mass: .
	^mass! !

!RigidBodyMorph methodsFor: 'accessing' stamp: 'hjo 3/6/2009 16:58'!
mass: anObject
		
	mass := anObject! !

!RigidBodyMorph methodsFor: 'stepping and presenter' stamp: 'hjo 3/6/2009 17:28'!
step

	super step.
	self center: self center + self velocity.
	self velocity: self velocity * 0.98! !

!RigidBodyMorph methodsFor: 'testing' stamp: 'hjo 3/6/2009 17:26'!
stepTime

	^50! !

!RigidBodyMorph methodsFor: 'accessing' stamp: 'hjo 3/6/2009 16:58'!
velocity

	velocity setDefault: #defaultVelocity for: self withSetter: #velocity: .
	^velocity! !

!RigidBodyMorph methodsFor: 'accessing' stamp: 'hjo 3/6/2009 16:58'!
velocity: anObject
		
	velocity := anObject! !

EllipseMorph subclass: #UnmovableBodyMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics'!

!UnmovableBodyMorph methodsFor: 'physics' stamp: 'hjo 3/7/2009 13:12'!
acceleratedBy: aPoint 

	"I shall not move!!!!"! !

!UnmovableBodyMorph methodsFor: 'physics' stamp: 'hjo 3/7/2009 13:13'!
forcedBy: aPoint 

	"I shall not move!!!!"! !

!UnmovableBodyMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/7/2009 15:34'!
initialize

	super initialize.
	self extent: 20@20! !
